namespace CMSMicroservice.Application.UserAddressCQ.Commands.CreateNewUserAddress;
public class CreateNewUserAddressCommandValidator : AbstractValidator<CreateNewUserAddressCommand>
{
    public CreateNewUserAddressCommandValidator()
    {
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.Title)
            .NotEmpty();
        RuleFor(model => model.Address)
            .NotEmpty();
        RuleFor(model => model.PostalCode)
            .NotEmpty();
        RuleFor(model => model.IsDefault)
            .NotNull();
        RuleFor(model => model.CityId)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserAddressCommand>.CreateWithOptions((CreateNewUserAddressCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
